#ifdef __MC68K__
	#include <PalmOS.h>

	#define __NEWMEMPTR(size) MemPtrNew(size)
	#define __FREEMEMPTR(ptr) MemPtrFree(ptr)
	#define __RESIZEMEMPTR(ptr,size) MemPtrResize(ptr,size)
	#define __MEMMOVE(to,source,len) MemMove(to,source,len)	
	#define __MEMPTRSIZE(ptr) MemPtrSize(ptr)
	#define __MEMHANDLETYPE MemHandle
	#define __MEMHANDLENEW(size)  MemHandleNew(size)
	#define __MEMHANDLEFREE(memH) MemHandleFree(memH)
	#define __MEMHANDLELOCK(memH) MemHandleLock(memH)
	#define __MEMHANDLEUNLOCK(memH) MemHandleUnlock(memH)
	#define __MEMHANDLERESIZE(memH,size) MemHandleResize(memH,size)
	#define __STRLEN(text)	StrLen(text)
#endif

#ifdef _WIN32
	#include <stdlib.h>
	#include <malloc.h>
	#include <string.h>

	#define __NEWMEMPTR(size) malloc(size)
	#define __FREEMEMPTR(ptr) free(ptr)
	#define __RESIZEMEMPTR(ptr,size) realloc(ptr,size)
	#define __MEMMOVE(to,source,len) memmove(to,source,len)	
	#define __MEMPTRSIZE(ptr) _msize(ptr)
	#define __STRLEN(text)	strlen(text)
#endif

 
