#ifndef __INC_HTTPRequest
#define __INC_HTTPRequest

#include "MKCString.h"
#include "HTTPBase.h"
#include "HTTPHeaders.h"

#define  errRqNoError  			0
#define  errRqConnectionNotSet	1
#define  errRqFailed			2

typedef enum HTTPRequestType {
				httpGet,
				httpPost,
				httpPut,
				httpDelete,
				httpHeader
} HTTPRequestType;


class HTTPConnection;
class HTTPResponse;

class HTTPRequest : public HTTPBase
{

private:
	HTTPConnection*  m_connection;
	CMKString m_LastStringExecute;

protected:
	CMKString m_userName;
	CMKString m_password;	
	HTTPHeaders  *m_headers;
	HTTPResponse *m_response;

	void fillHeaderValues();
	void addAuthorization();
	
public:
	HTTPRequestType verb;	
	CMKString domain;
	short	  port;
	CMKString path;
	CMKString fileName;
	CMKString queryString;
	CMKString data;

	HTTPHeaders	   *getHeaders() { return m_headers; }
	HTTPResponse   *getResponse() { return m_response; }
	HTTPConnection *getConnection() { return m_connection; }

	short execute();
	short execute(HTTPRequestType verb, char* url, char *data = NULL);
	
	void GetLastStringSendToServer(CMKString& rMKString) { rMKString = m_LastStringExecute; }
	
	void setAuthorization(char* user, char* pass); //Setear user NULL para deshabilitar envio de autho

	HTTPRequest(bool secure = false);
	HTTPRequest(HTTPConnection *connection);
	virtual ~HTTPRequest();
};

#endif