#ifndef __INC_INetSocket
#define __INC_INetSocket

#include <NetMgr.h>

#define  SOCKET_DEF_TIMEOUT 500

// Errors 
#define errNoError			0
#define errCantFindLib 		1
#define errCantOpenLib 		2
#define errCantCreateSocket 3
#define errReleasingSocket 	4
#define errClosingLib 		5
#define errCantResolveHost 	6
#define errSending 			7
#define errReceiving 		8
#define errShutDownServer	9

// Status
enum SktStatus 
{
	sktConnected   	  	= 0x0001,
	sktNoSocket		  	= 0x0002,
	sktNoConnected 	  	= 0x0006,
	sktClosedByRemote 	= 0x000D,
	sktShutDownByServer = 0x000E
};

class INetSocket
{
public:
	INetSocket();
	virtual ~INetSocket();

	virtual bool connect(char* addr, unsigned short port); 
	bool close(); 
	bool connected();					//Devuelve si est conectado
		
	virtual unsigned short send(char* data, unsigned short dataLength);
	virtual unsigned short receive(char* data, unsigned short dataLength);

	void setTimeOut(short timeOut) { m_timeOut = timeOut; }
	short getTimeOut() { return m_timeOut; }
	
	short getLastError() { return m_lastError; }
	Err getPalmError() { return m_palmError; }

protected:
	virtual bool createSocket();
	virtual bool releaseSocket();
	void setStatusFlag();
	
protected:
	Err			 m_palmError;
	short		 m_lastError;
	SktStatus	 m_status;

	NetSocketRef m_netSocketRef;
	short		 m_timeOut;

private:
	unsigned short LibRef;
};

#endif