#ifndef SSLSocket_H
#define SSLSocket_H

#include "INetSocket.h"
#define export exporta		// Safe error in ssllib.h
#include <ssllib.h>

// Errors SSL
#define errSSL					100
#define errSSLNoError			0
#define errSSLCantFindLib		errSSL + 1 // 101
#define errSSLCantOpen			errSSL + 2 // 102
#define errSSLCantCreateSocket	errSSL + 3 // 103
#define errSSLReleasingSocket 	errSSL + 4 // 104
#define errSSLClosingLib 		errSSL + 5 // 105
#define errSSLCantResolveHost 	errSSL + 6 // 106
#define errSSLSending			errSSL + 7 // 107
#define errSSLReceiving			errSSL + 8 // 108
#define errSSLShutDownServer	errSSL + 9 // 109


class SSLSocket : public INetSocket
{
public:
	SSLSocket();
	virtual ~SSLSocket();
	
	virtual bool connect(char* addr, unsigned short port); 

	virtual unsigned short send(char* data, unsigned short dataLength);
	virtual unsigned short receive(char* data, unsigned short dataLength);

protected:
	virtual bool createSocket();
	virtual bool releaseSocket();
	
	bool releaseSocket(bool callBaseReleaseSocket = true);
	
private:
	static Int32 VerifyCallback(SslCallback *callbackStruct, Int32 command, Int32 flavor, void *info);
	UInt32 GetTimeOutInMiliSeconds();
	
private:
	UInt16		m_SSL_LibRef;
	SslLib*		m_SSL_pContextTemplate;
	SslContext* m_SSL_pContext;
};

#endif	// SSLSocket_H
